/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse sqlparse
#define yylex   sqllex
#define yyerror sqlerror
#define yylval  sqllval
#define yychar  sqlchar
#define yydebug sqldebug
#define yynerrs sqlnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     L_SELECT = 258,
     L_FROM = 259,
     L_WHERE = 260,
     L_AS = 261,
     L_JOIN = 262,
     L_ON = 263,
     L_ORDER = 264,
     L_BY = 265,
     L_ORDER_ASC = 266,
     L_ORDER_DSC = 267,
     L_DISTINCT = 268,
     L_BETWEEN = 269,
     L_IN = 270,
     L_GROUP = 271,
     L_INSERT = 272,
     L_INTO = 273,
     L_VALUES = 274,
     L_UPDATE = 275,
     L_SET = 276,
     L_DOT = 277,
     L_STAR = 278,
     L_COMMA = 279,
     L_NULL = 280,
     L_LBRACKET = 281,
     L_RBRACKET = 282,
     L_IDENT = 283,
     L_EQ = 284,
     L_IS = 285,
     L_LIKE = 286,
     L_GT = 287,
     L_LT = 288,
     L_GEQ = 289,
     L_LEQ = 290,
     L_NOT = 291,
     L_AND = 292,
     L_OR = 293,
     L_MINUS = 294,
     L_PLUS = 295,
     L_DIV = 296,
     L_STRING = 297
   };
#endif
#define L_SELECT 258
#define L_FROM 259
#define L_WHERE 260
#define L_AS 261
#define L_JOIN 262
#define L_ON 263
#define L_ORDER 264
#define L_BY 265
#define L_ORDER_ASC 266
#define L_ORDER_DSC 267
#define L_DISTINCT 268
#define L_BETWEEN 269
#define L_IN 270
#define L_GROUP 271
#define L_INSERT 272
#define L_INTO 273
#define L_VALUES 274
#define L_UPDATE 275
#define L_SET 276
#define L_DOT 277
#define L_STAR 278
#define L_COMMA 279
#define L_NULL 280
#define L_LBRACKET 281
#define L_RBRACKET 282
#define L_IDENT 283
#define L_EQ 284
#define L_IS 285
#define L_LIKE 286
#define L_GT 287
#define L_LT 288
#define L_GEQ 289
#define L_LEQ 290
#define L_NOT 291
#define L_AND 292
#define L_OR 293
#define L_MINUS 294
#define L_PLUS 295
#define L_DIV 296
#define L_STRING 297




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

#include <stdlib.h>
#include <stdio.h>
#include <glib.h>
#include <string.h>

#include "sql_parser.h"
#include "sql_tree.h"
#include "mem.h"

int sqlerror (char *);
int sqllex ();

extern sql_statement *sql_result;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 17 "parser.y"
typedef union YYSTYPE {
void *v;
char *str;
int i;
GList *list;
sql_field *f;
sql_field_item *fi;
sql_table *t;
sql_condition *c;
sql_where *w;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 197 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 209 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  16
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   138

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  27
/* YYNRULES -- Number of rules. */
#define YYNRULES  69
/* YYNRULES -- Number of states. */
#define YYNSTATES  121

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   297

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    19,    28,    34,    36,
      40,    44,    45,    47,    48,    51,    52,    56,    57,    59,
      61,    62,    66,    67,    69,    73,    75,    79,    81,    85,
      87,    89,    91,    93,    95,    99,   101,   103,   105,   107,
     109,   113,   115,   119,   124,   127,   130,   131,   133,   139,
     141,   145,   147,   149,   151,   154,   158,   162,   166,   168,
     170,   172,   174,   177,   179,   181,   183,   185,   187,   191
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      44,     0,    -1,    45,    -1,    46,    -1,    47,    -1,     3,
      50,    55,     4,    56,    51,    52,    53,    54,    -1,    17,
      18,    62,    49,    19,    26,    55,    27,    -1,    20,    62,
      21,    48,    51,    -1,    67,    -1,    67,    24,    48,    -1,
      26,    55,    27,    -1,    -1,    13,    -1,    -1,     5,    66,
      -1,    -1,     9,    10,    55,    -1,    -1,    11,    -1,    12,
      -1,    -1,    16,    10,    55,    -1,    -1,    57,    -1,    57,
      24,    55,    -1,    62,    -1,    62,    24,    56,    -1,    61,
      -1,    61,     6,    28,    -1,    23,    -1,    25,    -1,    42,
      -1,    28,    -1,    58,    -1,    59,    22,    58,    -1,    39,
      -1,    40,    -1,    23,    -1,    41,    -1,    59,    -1,    61,
      60,    61,    -1,    45,    -1,    26,    61,    27,    -1,    28,
      26,    55,    27,    -1,    64,    63,    -1,     6,    28,    -1,
      -1,    28,    -1,    62,     7,    64,     8,    69,    -1,    45,
      -1,    26,    64,    27,    -1,    37,    -1,    38,    -1,    69,
      -1,    36,    66,    -1,    66,    65,    66,    -1,    26,    66,
      27,    -1,    57,    29,    57,    -1,    29,    -1,    30,    -1,
      36,    -1,    15,    -1,    36,    15,    -1,    31,    -1,    32,
      -1,    33,    -1,    34,    -1,    35,    -1,    57,    68,    57,
      -1,    57,    14,    57,    37,    57,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    53,    53,    54,    55,    58,    62,    66,    70,    71,
      74,    75,    78,    79,    82,    83,    86,    87,    90,    91,
      92,    96,    97,   100,   101,   104,   105,   108,   109,   112,
     113,   114,   115,   117,   118,   121,   122,   123,   124,   127,
     128,   129,   130,   131,   134,   137,   138,   141,   142,   143,
     144,   147,   148,   151,   152,   153,   155,   158,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   173,   175
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "L_SELECT", "L_FROM", "L_WHERE", "L_AS", 
  "L_JOIN", "L_ON", "L_ORDER", "L_BY", "L_ORDER_ASC", "L_ORDER_DSC", 
  "L_DISTINCT", "L_BETWEEN", "L_IN", "L_GROUP", "L_INSERT", "L_INTO", 
  "L_VALUES", "L_UPDATE", "L_SET", "L_DOT", "L_STAR", "L_COMMA", "L_NULL", 
  "L_LBRACKET", "L_RBRACKET", "L_IDENT", "L_EQ", "L_IS", "L_LIKE", "L_GT", 
  "L_LT", "L_GEQ", "L_LEQ", "L_NOT", "L_AND", "L_OR", "L_MINUS", "L_PLUS", 
  "L_DIV", "L_STRING", "$accept", "statement", "select_statement", 
  "insert_statement", "update_statement", "set_list", "opt_fields_list", 
  "opt_distinct", "opt_where", "opt_orderby", "opt_ordertype", 
  "opt_groupby", "fields_list", "tables_list", "field", "field_item", 
  "field_name", "field_op", "field_raw", "table", "opt_table_as", 
  "table_simple", "logic_operator", "where_list", "set_item", 
  "condition_operator", "where_item", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    43,    44,    44,    44,    45,    46,    47,    48,    48,
      49,    49,    50,    50,    51,    51,    52,    52,    53,    53,
      53,    54,    54,    55,    55,    56,    56,    57,    57,    58,
      58,    58,    58,    59,    59,    60,    60,    60,    60,    61,
      61,    61,    61,    61,    62,    63,    63,    64,    64,    64,
      64,    65,    65,    66,    66,    66,    66,    67,    68,    68,
      68,    68,    68,    68,    68,    68,    68,    68,    69,    69
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     9,     8,     5,     1,     3,
       3,     0,     1,     0,     2,     0,     3,     0,     1,     1,
       0,     3,     0,     1,     3,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     3,     4,     2,     2,     0,     1,     5,     1,
       3,     1,     1,     1,     2,     3,     3,     3,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     3,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    13,     0,     0,     0,     2,     3,     4,    12,     0,
       0,     0,    47,    49,     0,    46,     1,    29,    30,     0,
      32,    31,    41,     0,    23,    33,    39,    27,    11,     0,
      46,     0,     0,     0,    44,     0,     0,     0,     0,     0,
       0,    37,    35,    36,    38,     0,     0,     0,    50,    46,
      15,     0,     8,    45,    42,     0,    15,    25,    24,    32,
      34,    28,    40,     0,     0,     0,     0,     7,     0,     0,
      43,    17,     0,    10,     0,     0,    48,     0,     0,    14,
      53,    57,     9,     0,    20,    26,     0,     0,    61,    58,
      59,    63,    64,    65,    66,    67,    60,     0,    27,     0,
      54,    51,    52,     0,     0,    18,    19,    22,     6,     0,
      62,    68,    56,    55,    16,     0,     5,     0,     0,    69,
      21
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     4,    22,     6,     7,    50,    47,     9,    67,    84,
     107,   116,    23,    56,    24,    25,    26,    45,    27,    29,
      34,    15,   103,    79,    52,    97,    80
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -62
static const yysigned_char yypact[] =
{
      44,    -5,    -8,    22,    18,   -62,   -62,   -62,   -62,    54,
      22,    22,   -62,   -62,     2,    16,   -62,   -62,   -62,    54,
      17,   -62,   -62,    23,    48,   -62,    59,    50,    37,    87,
      -1,    22,    54,    69,   -62,    76,    54,    22,    54,    -4,
      70,   -62,   -62,   -62,   -62,    54,    54,    86,   -62,    98,
     113,    90,    96,   -62,   -62,    94,   113,    71,   -62,   -62,
     -62,   -62,    61,    95,    97,    54,    26,   -62,    54,    54,
     -62,   115,    22,   -62,    54,    78,   -62,    26,    26,    21,
     -62,   -62,   -62,   116,    55,   -62,   100,    54,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   -62,   110,    54,    47,    -7,
      21,   -62,   -62,    26,    54,   -62,   -62,   112,   -62,    92,
     -62,   -62,   -62,    21,   -62,   120,   -62,    54,    54,   -62,
     -62
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -62,   -62,     4,   -62,   -62,    62,   -62,   -62,    77,   -62,
     -62,   -62,   -35,    60,   -32,    99,   -62,   -62,   -17,     3,
     -62,     1,   -62,   -61,   -62,   -62,    72
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      51,    55,    35,    58,     5,    33,    14,    13,     8,    31,
      10,    63,    30,    28,    13,    13,    99,   100,    16,    17,
     112,    18,    33,    32,    59,     1,    48,    37,    62,     1,
     101,   102,    49,    75,    75,    13,    81,    51,    21,    86,
      57,    13,   113,    36,    31,    75,    75,     1,    11,    17,
      12,    18,    77,    40,    20,   109,    40,     1,   101,   102,
      98,     2,    78,    46,     3,   111,   105,   106,    21,   114,
      41,    75,    38,    41,    54,    57,    13,    17,    31,    18,
      19,    39,    20,   120,    41,   119,    42,    43,    44,    42,
      43,    44,    87,    88,    31,    72,    21,    53,    61,    41,
      42,    43,    44,    54,    33,    64,    65,    89,    90,    91,
      92,    93,    94,    95,    96,    42,    43,    44,    66,    68,
      69,    70,    73,    74,    83,   110,   104,   108,   115,   117,
     118,    82,    85,    71,     0,     0,     0,    76,    60
};

static const yysigned_char yycheck[] =
{
      32,    36,    19,    38,     0,     6,     3,     3,    13,     7,
      18,    46,    11,    10,    10,    11,    77,    78,     0,    23,
      27,    25,     6,    21,    28,     3,    27,     4,    45,     3,
      37,    38,    31,    65,    66,    31,    68,    69,    42,    74,
      37,    37,   103,    26,     7,    77,    78,     3,    26,    23,
      28,    25,    26,     6,    28,    87,     6,     3,    37,    38,
      77,    17,    36,    26,    20,    97,    11,    12,    42,   104,
      23,   103,    24,    23,    27,    72,    72,    23,     7,    25,
      26,    22,    28,   118,    23,   117,    39,    40,    41,    39,
      40,    41,    14,    15,     7,    24,    42,    28,    28,    23,
      39,    40,    41,    27,     6,    19,     8,    29,    30,    31,
      32,    33,    34,    35,    36,    39,    40,    41,     5,    29,
      24,    27,    27,    26,     9,    15,    10,    27,    16,    37,
      10,    69,    72,    56,    -1,    -1,    -1,    65,    39
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    17,    20,    44,    45,    46,    47,    13,    50,
      18,    26,    28,    45,    62,    64,     0,    23,    25,    26,
      28,    42,    45,    55,    57,    58,    59,    61,    62,    62,
      64,     7,    21,     6,    63,    61,    26,     4,    24,    22,
       6,    23,    39,    40,    41,    60,    26,    49,    27,    64,
      48,    57,    67,    28,    27,    55,    56,    62,    55,    28,
      58,    28,    61,    55,    19,     8,     5,    51,    29,    24,
      27,    51,    24,    27,    26,    57,    69,    26,    36,    66,
      69,    57,    48,     9,    52,    56,    55,    14,    15,    29,
      30,    31,    32,    33,    34,    35,    36,    68,    61,    66,
      66,    37,    38,    65,    10,    11,    12,    53,    27,    57,
      15,    57,    27,    66,    55,    16,    54,    37,    10,    57,
      55
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 53 "parser.y"
    {sql_result = sql_statement_build (SQL_select, yyvsp[0].v);;}
    break;

  case 3:
#line 54 "parser.y"
    {sql_result = sql_statement_build (SQL_insert, yyvsp[0].v);;}
    break;

  case 4:
#line 55 "parser.y"
    {sql_result = sql_statement_build (SQL_update, yyvsp[0].v);;}
    break;

  case 5:
#line 59 "parser.y"
    {yyval.v = sql_select_statement_build (yyvsp[-7].i, yyvsp[-6].list, yyvsp[-4].list, yyvsp[-3].w, yyvsp[-2].list, yyvsp[-1].i, yyvsp[0].list);;}
    break;

  case 6:
#line 63 "parser.y"
    {yyval.v = sql_insert_statement_build (yyvsp[-5].t, yyvsp[-4].list, yyvsp[-1].list);;}
    break;

  case 7:
#line 67 "parser.y"
    {yyval.v = sql_update_statement_build (yyvsp[-3].t, yyvsp[-1].list, yyvsp[0].w);;}
    break;

  case 8:
#line 70 "parser.y"
    {yyval.list = g_list_append (NULL, yyvsp[0].c);;}
    break;

  case 9:
#line 71 "parser.y"
    {yyval.list = g_list_prepend (yyvsp[0].list, yyvsp[-2].c);;}
    break;

  case 10:
#line 74 "parser.y"
    {yyval.list = yyvsp[-1].list;;}
    break;

  case 11:
#line 75 "parser.y"
    {yyval.list = NULL;;}
    break;

  case 12:
#line 78 "parser.y"
    {yyval.i = 1;;}
    break;

  case 13:
#line 79 "parser.y"
    {yyval.i = 0;;}
    break;

  case 14:
#line 82 "parser.y"
    {yyval.w = yyvsp[0].w;;}
    break;

  case 15:
#line 83 "parser.y"
    {yyval.w = NULL;;}
    break;

  case 16:
#line 86 "parser.y"
    {yyval.list = yyvsp[0].list;;}
    break;

  case 17:
#line 87 "parser.y"
    {yyval.list = NULL;;}
    break;

  case 18:
#line 90 "parser.y"
    {yyval.i = 0;;}
    break;

  case 19:
#line 91 "parser.y"
    {yyval.i = 1;;}
    break;

  case 20:
#line 92 "parser.y"
    {yyval.i = 0;;}
    break;

  case 21:
#line 96 "parser.y"
    {yyval.list = yyvsp[0].list;;}
    break;

  case 22:
#line 97 "parser.y"
    {yyval.list = NULL;;}
    break;

  case 23:
#line 100 "parser.y"
    {yyval.list = g_list_append (NULL, yyvsp[0].f);;}
    break;

  case 24:
#line 101 "parser.y"
    {yyval.list = g_list_prepend (yyvsp[0].list, yyvsp[-2].f);;}
    break;

  case 25:
#line 104 "parser.y"
    {yyval.list = g_list_append (NULL, yyvsp[0].t);;}
    break;

  case 26:
#line 105 "parser.y"
    {yyval.list = g_list_prepend (yyvsp[0].list, yyvsp[-2].t);;}
    break;

  case 27:
#line 108 "parser.y"
    {yyval.f = sql_field_build (yyvsp[0].fi);;}
    break;

  case 28:
#line 109 "parser.y"
    {yyval.f = sql_field_set_as (sql_field_build (yyvsp[-2].fi), yyvsp[0].str);;}
    break;

  case 29:
#line 112 "parser.y"
    {yyval.str = memsql_strdup("*");;}
    break;

  case 30:
#line 113 "parser.y"
    {yyval.str = memsql_strdup("null");;}
    break;

  case 31:
#line 114 "parser.y"
    {yyval.str = yyvsp[0].str;;}
    break;

  case 32:
#line 115 "parser.y"
    {yyval.str = yyvsp[0].str;;}
    break;

  case 33:
#line 117 "parser.y"
    {yyval.list = g_list_append(NULL, yyvsp[0].str);;}
    break;

  case 34:
#line 118 "parser.y"
    {yyval.list = g_list_append(yyvsp[-2].list, yyvsp[0].str);;}
    break;

  case 35:
#line 121 "parser.y"
    {yyval.i = SQL_minus;;}
    break;

  case 36:
#line 122 "parser.y"
    {yyval.i = SQL_plus;;}
    break;

  case 37:
#line 123 "parser.y"
    {yyval.i = SQL_times;;}
    break;

  case 38:
#line 124 "parser.y"
    {yyval.i = SQL_div;;}
    break;

  case 39:
#line 127 "parser.y"
    {yyval.fi = sql_field_item_build (yyvsp[0].list);;}
    break;

  case 40:
#line 128 "parser.y"
    {yyval.fi = sql_field_item_build_equation (yyvsp[-2].fi, yyvsp[0].fi, yyvsp[-1].i);;}
    break;

  case 41:
#line 129 "parser.y"
    {yyval.fi = sql_field_item_build_select (yyvsp[0].v);;}
    break;

  case 42:
#line 130 "parser.y"
    {yyval.fi = yyvsp[-1].fi;;}
    break;

  case 43:
#line 131 "parser.y"
    {yyval.fi = sql_field_build_function(yyvsp[-3].str, yyvsp[-1].list); ;}
    break;

  case 44:
#line 134 "parser.y"
    {yyval.t = sql_table_set_as (yyvsp[-1].t, yyvsp[0].str);;}
    break;

  case 45:
#line 137 "parser.y"
    {yyval.str = yyvsp[0].str;;}
    break;

  case 46:
#line 138 "parser.y"
    {yyval.str = NULL;;}
    break;

  case 47:
#line 141 "parser.y"
    {yyval.t = sql_table_build (yyvsp[0].str); memsql_free (yyvsp[0].str);;}
    break;

  case 48:
#line 142 "parser.y"
    {yyval.t = sql_table_build_join (yyvsp[-4].t, yyvsp[-2].t, yyvsp[0].c); ;}
    break;

  case 49:
#line 143 "parser.y"
    {yyval.t = sql_table_build_select (yyvsp[0].v);;}
    break;

  case 50:
#line 144 "parser.y"
    {yyval.t = yyvsp[-1].t;;}
    break;

  case 51:
#line 147 "parser.y"
    {yyval.i = SQL_and;;}
    break;

  case 52:
#line 148 "parser.y"
    {yyval.i = SQL_or;;}
    break;

  case 53:
#line 151 "parser.y"
    {yyval.w = sql_where_build_single (yyvsp[0].c);;}
    break;

  case 54:
#line 152 "parser.y"
    {yyval.w = sql_where_build_negated (yyvsp[0].w);;}
    break;

  case 55:
#line 154 "parser.y"
    {yyval.w = sql_where_build_pair (yyvsp[-2].w, yyvsp[0].w, yyvsp[-1].i);;}
    break;

  case 56:
#line 155 "parser.y"
    {yyval.w = yyvsp[-1].w;;}
    break;

  case 57:
#line 158 "parser.y"
    {yyval.c = sql_build_condition (yyvsp[-2].f, yyvsp[0].f, SQL_eq);;}
    break;

  case 58:
#line 161 "parser.y"
    {yyval.i = SQL_eq;;}
    break;

  case 59:
#line 162 "parser.y"
    {yyval.i = SQL_is;;}
    break;

  case 60:
#line 163 "parser.y"
    {yyval.i = SQL_not;;}
    break;

  case 61:
#line 164 "parser.y"
    {yyval.i = SQL_in;;}
    break;

  case 62:
#line 165 "parser.y"
    {yyval.i = SQL_notin;;}
    break;

  case 63:
#line 166 "parser.y"
    {yyval.i = SQL_like;;}
    break;

  case 64:
#line 167 "parser.y"
    {yyval.i = SQL_gt;;}
    break;

  case 65:
#line 168 "parser.y"
    {yyval.i = SQL_lt;;}
    break;

  case 66:
#line 169 "parser.y"
    {yyval.i = SQL_geq;;}
    break;

  case 67:
#line 170 "parser.y"
    {yyval.i = SQL_leq;;}
    break;

  case 68:
#line 174 "parser.y"
    {yyval.c = sql_build_condition (yyvsp[-2].f, yyvsp[0].f, yyvsp[-1].i);;}
    break;

  case 69:
#line 176 "parser.y"
    {yyval.c = sql_build_condition_between (yyvsp[-4].f, yyvsp[-2].f, yyvsp[0].f);;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1538 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 179 "parser.y"


